<?
  header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // Datum der Vergangenheit
  header ("Last-Modified: " . gmdate ("D, d M Y H:i:s") . " GMT"); // immer geändert
  header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
  header ("Pragma: no-cache");                          // HTTP/1.0
  header ("Content-type: text/xml");

  /***************************************************************************
  * Konfiguration
  ***************************************************************************/
  include "onlineShop_Config_VirtueMart2.inc.php";
  
  /***************************************************************************
  * Hilfsfunktionen
  ***************************************************************************/
  function html($string) 
  {
    return htmlspecialchars($string, ENT_COMPAT | ENT_HTML401,'ISO-8859-1');
  }  
  /***************************************************************************
  * Ausgabe eines Fehlers
  ***************************************************************************/
  function echoError($_context, $_message)
  {
    echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
    echo "<error>\n";
	  echo "  <context>" . utf8_encode(html( $_context )) . "</context>"."\n";
	  echo "  <message>" . utf8_encode(html( $_message )) . "</message>"."\n";
	  echo "</error>\n";
  }

  /***************************************************************************
  * Ausgabe
  ***************************************************************************/

  if(!isset($_REQUEST["func"]))
  {
    echoError("Initialization","Fehlender Parameter");
    exit;
  }

  switch ($_REQUEST["func"])
  {
    case "checkVersion":       checkVersion(); exit;
    case "getOrders":          getOrders(); exit;
    case "getOrderStatusList": getOrderStatusList(); exit; 
    case "setOrderStatus":     setOrderStatus(); exit; 
    case "getPaymentwaysList": getPaymentwaysList(); exit; 
    default:
      echoError("Initialization","Unbekannte Funktion");
      exit;
  }

  /***************************************************************************
  * Funktion checkVersion
  ***************************************************************************/
  function checkVersion()
  {
    ob_start();

	  echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
	  echo "<interface_informations>\n";
	  echo "  <version>1.1</version>\n";
	  echo "  <shopsystem>VirtueMart 2.0.18</shopsystem>\n";
	  echo "</interface_informations>\n";
  
    ob_end_flush();
  } //************************************************************************

  /***************************************************************************
  * Funktion setOrderStatus
  ***************************************************************************/
  function setOrderStatus()
  {
    if (! isset($_REQUEST["orderid"]))
    {
      echoError("Check Function Params" ,"Keine OrderID angegeben.");
      return;
    }
    if (! isset($_REQUEST["orderstatus"]))
    {
      echoError("Check Function Params" ,"Kein Orderstatus angegeben.");
      return;
    }

    global $tabellen_praefix_vm;
    global $tabellen_suffix_vm_lang;
    global $datenbank_server;
    global $datenbank_benutzer;
    global $datenbank_passwort;
    global $datenbank_name;
    global $vm_user_id;

    ob_start();

    //Mit der Datenbank verbinden
	  $sql_con = mysql_connect($datenbank_server, $datenbank_benutzer, $datenbank_passwort);
    if (mysql_errno($sql_con)<>0) 
    {
      ob_end_clean();
      echoError("mysql_connect",mysql_error($sql_con));
      mysql_close($sql_con);
      return;
    }
	  mysql_select_db($datenbank_name, $sql_con);
    if (mysql_errno($sql_con)<>0) 
    {
      ob_end_clean();
      echoError("mysql_select_db",mysql_error($sql_con));
      mysql_close($sql_con);
      return;
    }

	  $sql_orders = "UPDATE {$tabellen_praefix_vm}_orders SET order_status='" . $_REQUEST["orderstatus"] . "', modified_on=NOW(), modified_by={$vm_user_id} WHERE virtuemart_order_id='" . $_REQUEST["orderid"] . "'";
	  $run_orders = mysql_query($sql_orders);
    if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_orders,mysql_error($sql_con)); mysql_close($sql_con); exit; }

	  $sql_orders = "UPDATE {$tabellen_praefix_vm}_order_items SET order_status='" . $_REQUEST["orderstatus"] . "', modified_on=NOW(), modified_by={$vm_user_id} WHERE virtuemart_order_id='" . $_REQUEST["orderid"] . "'";
	  $run_orders = mysql_query($sql_orders);
    if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_orders,mysql_error($sql_con)); mysql_close($sql_con); exit; }

	  $sql_orders = "INSERT INTO {$tabellen_praefix_vm}_order_histories(virtuemart_order_id, order_status_code, created_on, created_by, modified_on, modified_by) VALUES ('".$_REQUEST["orderid"]."','".$_REQUEST["orderstatus"]."',NOW(),{$vm_user_id},NOW(),{$vm_user_id})";
	  $run_orders = mysql_query($sql_orders);
    if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_orders,mysql_error($sql_con)); mysql_close($sql_con); exit; }

    mysql_close($sql_con);

	  echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
	  echo "<set_order_status>\n";
	  echo "  <result>OK</result>\n";
	  echo "</set_order_status>\n";
  
    ob_end_flush();
  } //************************************************************************

  /***************************************************************************
  * Funktion getOrderStatusList
  ***************************************************************************/
  function getOrderStatusList()
  {
    global $tabellen_praefix_vm;
    global $tabellen_suffix_vm_lang;
    global $datenbank_server;
    global $datenbank_benutzer;
    global $datenbank_passwort;
    global $datenbank_name;

    ob_start();

    //Mit der Datenbank verbinden
	  $sql_con = mysql_connect($datenbank_server, $datenbank_benutzer, $datenbank_passwort);
    if (mysql_errno($sql_con)<>0) 
    {
      ob_end_clean();
      echoError("mysql_connect",mysql_error($sql_con));
      mysql_close($sql_con);
      return;
    }
	  mysql_select_db($datenbank_name, $sql_con);
    if (mysql_errno($sql_con)<>0) 
    {
      ob_end_clean();
      echoError("mysql_select_db",mysql_error($sql_con));
      mysql_close($sql_con);
      return;
    }
  
    $sql_order_status = "SELECT * FROM {$tabellen_praefix_vm}_orderstates";
	  $run_order_status = mysql_query($sql_order_status);

    if (mysql_errno($sql_con)<>0) 
    {
      ob_end_clean();
      echoError("sql_order_status",mysql_error($sql_con));
      mysql_close($sql_con);
      return;
    }
    mysql_close($sql_con);

	  echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
	  echo "<order_status>\n";
    while($row_order_status = mysql_fetch_array($run_order_status))
    {
      echo "  <order_status_item order_status_id=\"" .utf8_encode(html($row_order_status['virtuemart_orderstate_id'])). "\" order_status_code=\"" .utf8_encode(html($row_order_status['order_status_code'])). "\" order_status_name=\"" .utf8_encode(html($row_order_status['order_status_name']))."\"/>\n";
    }
    echo "</order_status>"."\n";
  
    ob_end_flush();
  } //************************************************************************

  /***************************************************************************
  * Funktion getPaymentwaysList
  ***************************************************************************/
  function getPaymentwaysList()
  {
    global $tabellen_praefix_vm;
    global $tabellen_suffix_vm_lang;
    global $datenbank_server;
    global $datenbank_benutzer;
    global $datenbank_passwort;
    global $datenbank_name;

    ob_start();

    //Mit der Datenbank verbinden
	  $sql_con = mysql_connect($datenbank_server, $datenbank_benutzer, $datenbank_passwort);
    if (mysql_errno($sql_con)<>0) 
    {
      ob_end_clean();
      echoError("mysql_connect",mysql_error($sql_con));
      mysql_close($sql_con);
      return;
    }
	  mysql_select_db($datenbank_name, $sql_con);
    if (mysql_errno($sql_con)<>0) 
    {
      ob_end_clean();
      echoError("mysql_select_db",mysql_error($sql_con));
      mysql_close($sql_con);
      return;
    }

  	$sql_payment = "SELECT * FROM {$tabellen_praefix_vm}_paymentmethods_{$tabellen_suffix_vm_lang}";
	  $run_payment = mysql_query($sql_payment);

    if (mysql_errno($sql_con)<>0) 
    {
      ob_end_clean();
      echoError("sql_payment",mysql_error($sql_con));
      mysql_close($sql_con);
      return;
    }
    mysql_close($sql_con);

	  echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
	  echo "<paymentways>\n";
    while($row_payment = mysql_fetch_array($run_payment))
    {
      echo "  <paymentway val=\"" .utf8_encode(html($row_payment['payment_name']))."\"/>\n";
    }
    echo "</paymentways>"."\n";
  
    ob_end_flush();
  } //************************************************************************
  
function internalGetCountry($_id)
{
    if ($_id = 0) { return ""; }	
	
    global $tabellen_praefix_vm;
    global $tabellen_suffix_vm_lang;
    global $datenbank_server;
    global $datenbank_benutzer;
    global $datenbank_passwort;
    global $datenbank_name;

  	$sql = "SELECT * FROM {$tabellen_praefix_vm}_countries WHERE virtuemart_country_id = '" . $_id . "'";
	  $run = mysql_query($sql);
	  if (mysql_errno($sql_con)<>0) { return ""; }
    $row = mysql_fetch_array($run);
    return $row['country_2_code'];
}

function internalGetState($_id)
{
	  if ($_id = 0) { return ""; }
	
    global $tabellen_praefix_vm;
    global $tabellen_suffix_vm_lang;
    global $datenbank_server;
    global $datenbank_benutzer;
    global $datenbank_passwort;
    global $datenbank_name;

  	$sql = "SELECT * FROM {$tabellen_praefix_vm}_states WHERE virtuemart_state_id = '" . $_id . "'";
	  $run = mysql_query($sql);
	  if (mysql_errno($sql_con)<>0) { return ""; }
    $row = mysql_fetch_array($run);
    return $row['state_2_code'];
}

  /***************************************************************************
  * Funktion getOrders
  ***************************************************************************/
  function getOrders()
  {
    if (! isset($_REQUEST["orderstatus"]))
    {
      echoError("Check Function Params" ,"Kein Orderstatus angegeben.");
      return;
    }
    
    global $tabellen_praefix;
    global $tabellen_praefix_vm;
    global $tabellen_suffix_vm_lang;
    global $datenbank_server;
    global $datenbank_benutzer;
    global $datenbank_passwort;
    global $datenbank_name;

    ob_start();

    //Mit der Datenbank verbinden
	  $sql_con = mysql_connect($datenbank_server, $datenbank_benutzer, $datenbank_passwort);
    if (mysql_errno($sql_con)<>0) 
    {
      ob_end_clean();
      echoError("mysql_connect",mysql_error($sql_con));
      mysql_close($sql_con);
      return;
    }
	  mysql_select_db($datenbank_name, $sql_con);
    if (mysql_errno($sql_con)<>0) 
    {
      ob_end_clean();
      echoError("mysql_select_db",mysql_error($sql_con));
      mysql_close($sql_con);
      return;
    }

    $selectOrderStatus = explode(" ",$_REQUEST["orderstatus"]);
    /* 
    if (count($selectOrderStatus) == 1 )
    {
      ob_end_clean();
      echoError("Read Function Params","Kein Orderstatus angegeben.");
      mysql_close($sql_con);
      return;
    }
    */
  
	  $sql_orders = "SELECT * FROM {$tabellen_praefix_vm}_orders WHERE";
	
	  reset($selectOrderStatus);
	  while (current($selectOrderStatus)) 
	  {
	    $sql_orders = $sql_orders . " (order_status = '".current($selectOrderStatus)."')";
	    next($selectOrderStatus);
	    if (current($selectOrderStatus)) {$sql_orders = $sql_orders . " or";}
	  }
	
	  $run_orders = mysql_query($sql_orders);
    if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_orders,mysql_error($sql_con)); mysql_close($sql_con); exit; }

	  echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
	  echo "<orders>\n";


  while($row_orders = mysql_fetch_array($run_orders))
  {

    $orderID = $row_orders['virtuemart_order_id'];
    $userID  = $row_orders['virtuemart_user_id'];
    
    $userName = "";
    $userEMail = "";
    if ($userID != 0)
    {
    	$sql_users = "SELECT * FROM {$tabellen_praefix}_users WHERE id = '$userID'";
	    $run_users = mysql_query($sql_users);
	    if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_users,mysql_error($sql_con)); mysql_close($sql_con); exit; }
      $row_users = mysql_fetch_array($run_users);
      $userName = $row_users['name'];
      $userEMail = $row_users['email'];
    } else
    {
  	  $sql_order_user_info = "SELECT * FROM {$tabellen_praefix_vm}_order_userinfos WHERE (virtuemart_order_id = '$orderID') and (address_type = 'BT')";
	    $run_order_user_info = mysql_query($sql_order_user_info);
  	  if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_order_user_info,mysql_error($sql_con)); mysql_close($sql_con); exit; }
      $row_order_user_info = mysql_fetch_array($run_order_user_info);
      $userName = $row_order_user_info['last_name'];
      $userEMail = $row_order_user_info['email'];
    }

    echo "<order order_id=\"" . utf8_encode(html($orderID)). 
             "\" user_id=\""  .utf8_encode(html($userID))  .
             "\" user_name=\""  .utf8_encode(html($userName))  .
             "\" user_email=\""  .utf8_encode(html($userEMail))  .
             "\" order_number=\""  .utf8_encode(html($row_orders['order_number']))  .
             "\" order_status_code=\""  .utf8_encode(html($row_orders['order_status']))  . "\">\n";

    echo "    <created>" . utf8_encode(html( date("d.m.Y H:m:s", strtotime($row_orders['created_on']))  )) . "</created>"."\n"; 
    echo "    <order_total>" . utf8_encode(html($row_orders['order_total'])) . "</order_total>"."\n";
    echo "    <order_subtotal>" . utf8_encode(html($row_orders['order_subtotal'])) . "</order_subtotal>"."\n";
    echo "    <order_tax>" . utf8_encode(html($row_orders['order_tax'])) . "</order_tax>"."\n";
    echo "    <order_shipping>" . utf8_encode(html($row_orders['order_shipment'])) . "</order_shipping>"."\n";
    echo "    <order_shipping_tax>" . utf8_encode(html($row_orders['order_shipment_tax'])) . "</order_shipping_tax>"."\n";         
    echo "    <order_payment_>" . utf8_encode(html($row_orders['order_payment'])) . "</order_payment_>"."\n";                      //NEU
    echo "    <order_payment_tax>" . utf8_encode(html($row_orders['order_payment_tax'])) . "</order_payment_tax>"."\n";            //NEU
    echo "    <coupon_discount>" . utf8_encode(html($row_orders['coupon_discount'])) . "</coupon_discount>"."\n";
    echo "    <order_discount>" . utf8_encode(html($row_orders['order_discount'])) . "</order_discount>"."\n";
    echo "    <ship_method_id>" . utf8_encode(html($row_orders['virtuemart_shipmentmethod_id'])) . "</ship_method_id>"."\n";
    echo "    <payment_method_id>" . utf8_encode(html($row_orders['virtuemart_paymentmethod_id'])) . "</payment_method_id>"."\n";  //NEU
    echo "    <customer_note>" . utf8_encode(html($row_orders['customer_note'])) . "</customer_note>"."\n";

  	$sql_ship = "SELECT * FROM {$tabellen_praefix_vm}_shipmentmethods_{$tabellen_suffix_vm_lang} WHERE virtuemart_shipmentmethod_id = '" . $row_orders['virtuemart_shipmentmethod_id'] . "'";
	  $run_ship = mysql_query($sql_ship);
	  if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_ship,mysql_error($sql_con)); mysql_close($sql_con); exit; }
    $row_ship = mysql_fetch_array($run_ship);
    echo "    <order_shippingname>" . utf8_encode(html($row_ship['shipment_name'])) . "</order_shippingname>"."\n";

  	$sql_payment = "SELECT * FROM {$tabellen_praefix_vm}_paymentmethods_{$tabellen_suffix_vm_lang} WHERE virtuemart_paymentmethod_id = '" . $row_orders['virtuemart_paymentmethod_id'] . "'";
	  $run_payment = mysql_query($sql_payment);
	  if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_payment,mysql_error($sql_con)); mysql_close($sql_con); exit; }
    $row_payment = mysql_fetch_array($run_payment);
    echo "    <order_payment>" . utf8_encode(html($row_payment['payment_name'])) . "</order_payment>"."\n";

    //Bestelladressen auslesen
    echo "    <order_user_infos>\n";
  	$sql_order_user_info = "SELECT * FROM {$tabellen_praefix_vm}_order_userinfos WHERE virtuemart_order_id = '$orderID'";
	  $run_order_user_info = mysql_query($sql_order_user_info);
	  if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_order_user_info,mysql_error($sql_con)); mysql_close($sql_con); exit; }
	  
    while($row_order_user_info = mysql_fetch_array($run_order_user_info)) 
    {
      echo "      <order_user_info address_type=\"" .utf8_encode(html($row_order_user_info['address_type'])). "\" address_type_name=\"" .utf8_encode(html($row_order_user_info['address_type_name'])). "\">\n";
      echo "        <company>" . utf8_encode(html($row_order_user_info['company'])) . "</company>"."\n";
      echo "        <title>" . utf8_encode(html($row_order_user_info['title'])) . "</title>"."\n";
      echo "        <last_name>" . utf8_encode(html($row_order_user_info['last_name'])) . "</last_name>"."\n";
      echo "        <first_name>" . utf8_encode(html($row_order_user_info['first_name'])) . "</first_name>"."\n";
      echo "        <middle_name>" . utf8_encode(html($row_order_user_info['middle_name'])) . "</middle_name>"."\n";
      echo "        <phone_1>" . utf8_encode(html($row_order_user_info['phone_1'])) . "</phone_1>"."\n";
      echo "        <phone_2>" . utf8_encode(html($row_order_user_info['phone_2'])) . "</phone_2>"."\n";
      echo "        <fax>" . utf8_encode(html($row_order_user_info['fax'])) . "</fax>"."\n";
      echo "        <address_1>" . utf8_encode(html($row_order_user_info['address_1'])) . "</address_1>"."\n";
      echo "        <address_2>" . utf8_encode(html($row_order_user_info['address_2'])) . "</address_2>"."\n";
      echo "        <city>" . utf8_encode(html($row_order_user_info['city'])) . "</city>"."\n";
      echo "        <state>" . utf8_encode(html(internalGetState($row_order_user_info['virtuemart_state_id']))) . "</state>"."\n";
      echo "        <country>" . utf8_encode(html(internalGetCountry($row_order_user_info['virtuemart_country_id']))) . "</country>"."\n";
      echo "        <zip>" . utf8_encode(html($row_order_user_info['zip'])) . "</zip>"."\n";
      echo "        <user_email>" . utf8_encode(html($row_order_user_info['email'])) . "</user_email>"."\n";
      //echo "        <extra_field_1>" . utf8_encode(html($row_order_user_info['extra_field_1'])) . "</extra_field_1>"."\n";
      //echo "        <extra_field_2>" . utf8_encode(html($row_order_user_info['extra_field_2'])) . "</extra_field_2>"."\n";
      //echo "        <extra_field_3>" . utf8_encode(html($row_order_user_info['extra_field_3'])) . "</extra_field_3>"."\n";
      //echo "        <extra_field_4>" . utf8_encode(html($row_order_user_info['extra_field_4'])) . "</extra_field_4>"."\n";
      //echo "        <extra_field_5>" . utf8_encode(html($row_order_user_info['extra_field_5'])) . "</extra_field_5>"."\n";
      //echo "        <bank_account_nr>" . utf8_encode(html($row_order_user_info['bank_account_nr'])) . "</bank_account_nr>"."\n";
      //echo "        <bank_name>" . utf8_encode(html($row_order_user_info['bank_name'])) . "</bank_name>"."\n";
      //echo "        <bank_sort_code>" . utf8_encode(html($row_order_user_info['bank_sort_code'])) . "</bank_sort_code>"."\n";
      //echo "        <bank_iban>" . utf8_encode(html($row_order_user_info['bank_iban'])) . "</bank_iban>"."\n";
      //echo "        <bank_account_holder>" . utf8_encode(html($row_order_user_info['bank_account_holder'])) . "</bank_account_holder>"."\n";
      //echo "        <bank_account_type>" . utf8_encode(html($row_order_user_info['bank_account_type'])) . "</bank_account_type>"."\n";
      echo "      </order_user_info>\n";
    }
    echo "    </order_user_infos>\n";

    //Alle Adressen des Kunden auslesen
    echo "    <user_infos>\n";
    if ($userID != 0)
    {
  	  $sql_user_info = "SELECT * FROM {$tabellen_praefix_vm}_userinfos WHERE virtuemart_user_id = '$userID'";
	    $run_user_info = mysql_query($sql_user_info);
	    if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_user_info,mysql_error($sql_con)); mysql_close($sql_con); exit; }
	  
      while($row_user_info = mysql_fetch_array($run_user_info)) 
      {
        echo "      <user_info address_type=\"" .utf8_encode(html($row_user_info['address_type'])). "\" address_type_name=\"" .utf8_encode(html($row_user_info['address_type_name'])). "\">\n";
        echo "        <name>" . utf8_encode(html($row_user_info['name'])) . "</name>"."\n";
        echo "        <company>" . utf8_encode(html($row_user_info['company'])) . "</company>"."\n";
        echo "        <title>" . utf8_encode(html($row_user_info['title'])) . "</title>"."\n";
        echo "        <last_name>" . utf8_encode(html($row_user_info['last_name'])) . "</last_name>"."\n";
        echo "        <first_name>" . utf8_encode(html($row_user_info['first_name'])) . "</first_name>"."\n";
        echo "        <middle_name>" . utf8_encode(html($row_user_info['middle_name'])) . "</middle_name>"."\n";
        echo "        <phone_1>" . utf8_encode(html($row_user_info['phone_1'])) . "</phone_1>"."\n";
        echo "        <phone_2>" . utf8_encode(html($row_user_info['phone_2'])) . "</phone_2>"."\n";
        echo "        <fax>" . utf8_encode(html($row_user_info['fax'])) . "</fax>"."\n";
        echo "        <address_1>" . utf8_encode(html($row_user_info['address_1'])) . "</address_1>"."\n";
        echo "        <address_2>" . utf8_encode(html($row_user_info['address_2'])) . "</address_2>"."\n";
        echo "        <city>" . utf8_encode(html($row_user_info['city'])) . "</city>"."\n";
        echo "        <state>" . utf8_encode(html(internalGetState($row_user_info['virtuemart_state_id']))) . "</state>"."\n";
        echo "        <country>" . utf8_encode(html(internalGetCountry($row_user_info['virtuemart_country_id']))) . "</country>"."\n";
        echo "        <zip>" . utf8_encode(html($row_user_info['zip'])) . "</zip>"."\n";
        //echo "        <user_email>" . utf8_encode(html($row_user_info['user_email'])) . "</user_email>"."\n";
        //echo "        <extra_field_1>" . utf8_encode(html($row_user_info['extra_field_1'])) . "</extra_field_1>"."\n";
        //echo "        <extra_field_2>" . utf8_encode(html($row_user_info['extra_field_2'])) . "</extra_field_2>"."\n";
        //echo "        <extra_field_3>" . utf8_encode(html($row_user_info['extra_field_3'])) . "</extra_field_3>"."\n";
        //echo "        <extra_field_4>" . utf8_encode(html($row_user_info['extra_field_4'])) . "</extra_field_4>"."\n";
        //echo "        <extra_field_5>" . utf8_encode(html($row_user_info['extra_field_5'])) . "</extra_field_5>"."\n";
        //echo "        <cdate>" . utf8_encode(html(date ("d.m.Y H:m:s", $row_user_info['cdate']))) . "</cdate>"."\n";
        //echo "        <mdate>" . utf8_encode(html(date ("d.m.Y H:m:s", $row_user_info['mdate']))) . "</mdate>"."\n";
        //echo "        <perms>" . utf8_encode(html($row_user_info['perms'])) . "</perms>"."\n";
        //echo "        <bank_account_nr>" . utf8_encode(html($row_user_info['bank_account_nr'])) . "</bank_account_nr>"."\n";
        //echo "        <bank_name>" . utf8_encode(html($row_user_info['bank_name'])) . "</bank_name>"."\n";
        //echo "        <bank_sort_code>" . utf8_encode(html($row_user_info['bank_sort_code'])) . "</bank_sort_code>"."\n";
        //echo "        <bank_iban>" . utf8_encode(html($row_user_info['bank_iban'])) . "</bank_iban>"."\n";
        //echo "        <bank_account_holder>" . utf8_encode(html($row_user_info['bank_account_holder'])) . "</bank_account_holder>"."\n";
        //echo "        <bank_account_type>" . utf8_encode(html($row_user_info['bank_account_type'])) . "</bank_account_type>"."\n";
        echo "      </user_info>\n";
      }
    }
    else
    { //Nochmal die Order User Infos drucken
    	$sql_order_user_info = "SELECT * FROM {$tabellen_praefix_vm}_order_userinfos WHERE virtuemart_order_id = '$orderID'";
	 		$run_order_user_info = mysql_query($sql_order_user_info);
	  	if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_order_user_info,mysql_error($sql_con)); mysql_close($sql_con); exit; }
	  
    	while($row_order_user_info = mysql_fetch_array($run_order_user_info)) 
    	{
      	echo "      <user_info address_type=\"" .utf8_encode(html($row_order_user_info['address_type'])). "\" address_type_name=\"" .utf8_encode(html($row_order_user_info['address_type_name'])). "\">\n";
      	echo "        <company>" . utf8_encode(html($row_order_user_info['company'])) . "</company>"."\n";
      	echo "        <title>" . utf8_encode(html($row_order_user_info['title'])) . "</title>"."\n";
      	echo "        <last_name>" . utf8_encode(html($row_order_user_info['last_name'])) . "</last_name>"."\n";
      	echo "        <first_name>" . utf8_encode(html($row_order_user_info['first_name'])) . "</first_name>"."\n";
      	echo "        <middle_name>" . utf8_encode(html($row_order_user_info['middle_name'])) . "</middle_name>"."\n";
      	echo "        <phone_1>" . utf8_encode(html($row_order_user_info['phone_1'])) . "</phone_1>"."\n";
      	echo "        <phone_2>" . utf8_encode(html($row_order_user_info['phone_2'])) . "</phone_2>"."\n";
      	echo "        <fax>" . utf8_encode(html($row_order_user_info['fax'])) . "</fax>"."\n";
      	echo "        <address_1>" . utf8_encode(html($row_order_user_info['address_1'])) . "</address_1>"."\n";
      	echo "        <address_2>" . utf8_encode(html($row_order_user_info['address_2'])) . "</address_2>"."\n";
      	echo "        <city>" . utf8_encode(html($row_order_user_info['city'])) . "</city>"."\n";
      	echo "        <state>" . utf8_encode(html(internalGetState($row_order_user_info['virtuemart_state_id']))) . "</state>"."\n";
      	echo "        <country>" . utf8_encode(html(internalGetCountry($row_order_user_info['virtuemart_country_id']))) . "</country>"."\n";
      	echo "        <zip>" . utf8_encode(html($row_order_user_info['zip'])) . "</zip>"."\n";
      	echo "        <user_email>" . utf8_encode(html($row_order_user_info['email'])) . "</user_email>"."\n";
      	//echo "        <extra_field_1>" . utf8_encode(html($row_order_user_info['extra_field_1'])) . "</extra_field_1>"."\n";
      	//echo "        <extra_field_2>" . utf8_encode(html($row_order_user_info['extra_field_2'])) . "</extra_field_2>"."\n";
      	//echo "        <extra_field_3>" . utf8_encode(html($row_order_user_info['extra_field_3'])) . "</extra_field_3>"."\n";
      	//echo "        <extra_field_4>" . utf8_encode(html($row_order_user_info['extra_field_4'])) . "</extra_field_4>"."\n";
      	//echo "        <extra_field_5>" . utf8_encode(html($row_order_user_info['extra_field_5'])) . "</extra_field_5>"."\n";
      	//echo "        <bank_account_nr>" . utf8_encode(html($row_order_user_info['bank_account_nr'])) . "</bank_account_nr>"."\n";
      	//echo "        <bank_name>" . utf8_encode(html($row_order_user_info['bank_name'])) . "</bank_name>"."\n";
      	//echo "        <bank_sort_code>" . utf8_encode(html($row_order_user_info['bank_sort_code'])) . "</bank_sort_code>"."\n";
      	//echo "        <bank_iban>" . utf8_encode(html($row_order_user_info['bank_iban'])) . "</bank_iban>"."\n";
      	//echo "        <bank_account_holder>" . utf8_encode(html($row_order_user_info['bank_account_holder'])) . "</bank_account_holder>"."\n";
      	//echo "        <bank_account_type>" . utf8_encode(html($row_order_user_info['bank_account_type'])) . "</bank_account_type>"."\n";
      	echo "      </user_info>\n";
    	}
    }
    echo "    </user_infos>\n";

    //Bestellpositionen auslesen
    echo "  <order_items>\n";
    $sql_order_item = "SELECT * FROM {$tabellen_praefix_vm}_order_items WHERE virtuemart_order_id = '$orderID'";
    $run_order_item = mysql_query($sql_order_item);
    if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_order_item,mysql_error($sql_con)); mysql_close($sql_con); exit; }
    
    while($row_order_item = mysql_fetch_array($run_order_item)) 
    {
      $productId = $row_order_item['virtuemart_product_id'];
      
      $sql_product_mf_xref = "SELECT * FROM {$tabellen_praefix_vm}_product_manufacturers WHERE virtuemart_product_id = '$productId'";
      $run_product_mf_xref = mysql_query($sql_product_mf_xref);
      if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_product_mf_xref,mysql_error($sql_con)); mysql_close($sql_con); exit; }
      $row_product_mf_xref = mysql_fetch_array($run_product_mf_xref);
      $manufacturerId = $row_product_mf_xref['virtuemart_manufacturer_id'];

      $sql_manufacturer = "SELECT * FROM {$tabellen_praefix_vm}_manufacturers_{$tabellen_suffix_vm_lang} WHERE virtuemart_manufacturer_id = '$manufacturerId'";
      $run_manufacturer = mysql_query($sql_manufacturer);
      if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_manufacturer,mysql_error($sql_con)); mysql_close($sql_con); exit; }
      $row_manufacturer = mysql_fetch_array($run_manufacturer);
      $manufacturerName = $row_manufacturer['mf_name'];

      $sql_product_prices = "SELECT * FROM {$tabellen_praefix_vm}_product_prices WHERE virtuemart_product_id = '$productId'";
      $run_product_prices = mysql_query($sql_product_prices);
      if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_product_prices,mysql_error($sql_con)); mysql_close($sql_con); exit; }
      $row_product_prices = mysql_fetch_array($run_product_prices);
      $productTaxID = $row_product_prices['product_tax_id'];

      $sql_tax_rate = "SELECT * FROM {$tabellen_praefix_vm}_calcs WHERE virtuemart_calc_id = '$productTaxID'";
      $run_tax_rate = mysql_query($sql_tax_rate);
      if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_tax_rate,mysql_error($sql_con)); mysql_close($sql_con); exit; }
      $row_tax_rate = mysql_fetch_array($run_tax_rate);
      $productTaxID = ($row_tax_rate['calc_value'] / 100);

      $sql_product = "SELECT * FROM {$tabellen_praefix_vm}_products WHERE virtuemart_product_id = '$productId'";
      $run_product = mysql_query($sql_product);
      if (mysql_errno($sql_con)<>0) { ob_end_clean(); echoError($sql_product,mysql_error($sql_con)); mysql_close($sql_con); exit; }
      $row_product = mysql_fetch_array($run_product);

      echo "      <order_item sku=\"".utf8_encode(html($row_order_item['order_item_sku']))."\" manufacturer=\"".utf8_encode(html($manufacturerName))."\">\n";
      echo "        <order_item_name>" . utf8_encode(html($row_order_item['order_item_name'])) . "</order_item_name>"."\n";
      echo "        <product_quantity>" . utf8_encode(html($row_order_item['product_quantity'])) . "</product_quantity>"."\n";
      echo "        <product_unit>" . utf8_encode(html($row_product['product_unit'])) . "</product_unit>"."\n";
      echo "        <product_item_price>" . utf8_encode(html($row_order_item['product_item_price'])) . "</product_item_price>"."\n";
      echo "        <product_final_price>" . utf8_encode(html($row_order_item['product_final_price'])) . "</product_final_price>"."\n";
      echo "        <product_tax_rate>" . utf8_encode(html($productTaxID)) . "</product_tax_rate>"."\n";
      echo "      </order_item>\n";
    }
    
    echo "  </order_items>\n";

    echo "</order>"."\n";
  }

  echo "</orders>"."\n";
  
  
  mysql_close($sql_con);
  
  ob_end_flush();
  }
  

?>
